#ifndef HAL_CMD_H_
#define HAL_CMD_H_

/*
 * Basic functions to form reply and request commands.
 */

/* Form request commands. */
void hal_cmd_connect_request(struct buffer *pkt);
void hal_cmd_disconnect_request(struct buffer *pkt);
void hal_cmd_cycle_begin_request(struct buffer *pkt);
void hal_cmd_cycle_run_request(struct buffer *pkt);
void hal_cmd_cycle_end_request(struct buffer *pkt);
void hal_cmd_write_prepare_request(struct buffer *pkt);
void hal_cmd_write_end_request(struct buffer *pkt);
void hal_cmd_read_prepare_request(struct buffer *pkt);
void hal_cmd_read_end_request(struct buffer *pkt);
void hal_cmd_read_inputs_request(struct buffer *pkt, unsigned int len, unsigned int off);
void hal_cmd_read_outputs_request(struct buffer *pkt, unsigned int len, unsigned int off);
void hal_cmd_write_inputs_request(struct buffer *pkt, unsigned int off,
				  const char inputs[HAL_IMAGE_MAX+1]);
void hal_cmd_write_outputs_request(struct buffer *pkt, unsigned int off,
				   const char outputs[HAL_IMAGE_MAX+1]);

/* Form reply commands. */
void hal_cmd_connect_reply(struct buffer *pkt, unsigned int inputs_sz,
			   unsigned int outputs_sz, int master);
void hal_cmd_disconnect_reply(struct buffer *pkt);
void hal_cmd_cycle_begin_reply(struct buffer *pkt);
void hal_cmd_cycle_run_reply(struct buffer *pkt);
void hal_cmd_cycle_end_reply(struct buffer *pkt);
void hal_cmd_write_prepare_reply(struct buffer *pkt);
void hal_cmd_write_end_reply(struct buffer *pkt);
void hal_cmd_read_prepare_reply(struct buffer *pkt);
void hal_cmd_read_end_reply(struct buffer *pkt);
void hal_cmd_write_inputs_reply(struct buffer *pkt);
void hal_cmd_write_outputs_reply(struct buffer *pkt);
void hal_cmd_read_inputs_reply(struct buffer *pkt, unsigned int off,
			       const char inputs[HAL_IMAGE_MAX+1]);
void hal_cmd_read_outputs_reply(struct buffer *pkt, unsigned int off,
				const char outputs[HAL_IMAGE_MAX+1]);

/* Form a reply error message for specified command. */
void hal_status_error_reply(struct buffer *pkt, const char *cmd,
			    const char error[HAL_STRING_MAX]);

#endif
